"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_1 = require("mobx");
function computed(proto, memberName, descriptor) {
    if (!descriptor) {
        descriptor = Object.getOwnPropertyDescriptor(proto, memberName);
    }
    var implementation = descriptor.value;
    descriptor.value = function bootstrapComputed() {
        var _this = this;
        var computedValue = mobx_1.computed(function () {
            return implementation.apply(_this);
        });
        this[memberName] = (function () {
            return computedValue.get();
        });
        return this[memberName]();
    };
    return descriptor;
}
exports.computed = computed;
//# sourceMappingURL=computed-decorator.js.map