"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mobx = require("mobx");
function getMobxLogOf(action, subject) {
    var log = [];
    var unRegister = mobx.spy(function (change) { return log.push(change); });
    try {
        action();
    }
    finally {
        unRegister();
    }
    log = log.filter(function (change) { return change.type; });
    if (subject) {
        log = log.filter(function (change) { return change.object === subject; });
    }
    return log;
}
exports.getMobxLogOf = getMobxLogOf;
//# sourceMappingURL=mobx.js.map