"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var mutable = require("../src");
var test_drivers_1 = require("../test-kit/test-drivers");
describe('MuObject', function () {
    it('should be optionally nullable', function () {
        var TestType = test_drivers_1.aDataTypeWithSpec({
            poly: mutable.Object.nullable().withDefault(null)
        }, 'Test');
        var test = new TestType();
        chai_1.expect(test.poly).to.equal(null);
    });
    it('should allow various types', function () {
        var Possib1 = test_drivers_1.aDataTypeWithSpec({
            value: mutable.String.withDefault('possib1')
        }, 'Possib1');
        var Possib2 = test_drivers_1.aDataTypeWithSpec({
            count: mutable.Number.withDefault(3.14),
            value: mutable.String.withDefault('possib2')
        }, 'Possib2');
        var TestType = test_drivers_1.aDataTypeWithSpec({
            poly: mutable.Object.nullable().withDefault(null)
        }, 'TestType');
        var test = new TestType();
        chai_1.expect(test.poly).to.equal(null);
        test.poly = new Possib1();
        chai_1.expect(test.poly.value).to.equal('possib1');
        test.poly = new Possib2();
        chai_1.expect(test.poly.value).to.equal('possib2');
    });
});
//# sourceMappingURL=base-class-poly.spec.js.map