"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mutable = require("../../src");
var chai_1 = require("chai");
describe('user defined class', function () {
    var UserClass, UserClassChild;
    before(function () {
        UserClass = mutable.define('UserClass', { spec: function (c) { return ({
                foo: mutable.Number
            }); } });
        UserClassChild = mutable.define('UserClassChild', { spec: function (c) { return ({
                bar: mutable.Number
            }); } }, UserClass);
    });
    it('is any', function () {
        chai_1.expect(mutable.isAny(UserClass), 'UserClass').to.be.true;
        chai_1.expect(mutable.isAny(UserClassChild), 'UserClassChild').to.be.true;
    });
    it('is mutable', function () {
        chai_1.expect(mutable.isMutable(UserClass), 'UserClass').to.be.true;
        chai_1.expect(mutable.isMutable(UserClassChild), 'UserClassChild').to.be.true;
    });
    it('is class', function () {
        chai_1.expect(mutable.isClass(UserClass), 'UserClass').to.be.true;
        chai_1.expect(mutable.isClass(UserClassChild), 'UserClassChild').to.be.true;
    });
    it('is not enum', function () {
        chai_1.expect(mutable.isEnum(UserClass), 'UserClass').to.be.false;
        chai_1.expect(mutable.isEnum(UserClassChild), 'UserClassChild').to.be.false;
    });
    it('is not nullable', function () {
        chai_1.expect(mutable.isNullable(UserClass), 'UserClass').to.be.false;
        chai_1.expect(mutable.isNullable(UserClassChild), 'UserClassChild').to.be.false;
    });
});
//# sourceMappingURL=reflection.spec.js.map