"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var mu = require("../../src");
var test_drivers_1 = require("../../test-kit/test-drivers");
describe('Type matchers', function () {
    describe('Field matcher', function () {
        var UserType = test_drivers_1.aDataTypeWithSpec({
            name: mu.String
        });
        it('should reject types that do not have the requested field', function () {
            chai_1.expect(function () {
                chai_1.expect(UserType).to.have.field('noSuchField');
            }).to.throw('expected a Type with a field noSuchField');
        });
        it('should reject objects that are not data types', function () {
            chai_1.expect(function () {
                chai_1.expect({}).to.have.field('');
            }).to.throw('expected a Type but got {}');
        });
    });
});
//# sourceMappingURL=dataTypeMatchers.spec.js.map