"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var mu = require("../../src");
var test_drivers_1 = require("../../test-kit/test-drivers");
describe('Read only instances', function () {
    var UserType, user;
    before('init type and instance', function () {
        UserType = test_drivers_1.aDataTypeWithSpec({
            name: mu.String
        });
        user = new UserType('momo');
    });
    it('are considered equal to their read-write counterparts', function () {
        chai_1.expect(function () { return chai_1.expect(user).to.equal(user.$asReadOnly()); }).not.to.throw();
        chai_1.expect(function () { return chai_1.expect(user.$asReadOnly()).to.equal(user); }).not.to.throw();
    });
});
//# sourceMappingURL=readOnlyInstanceMatchers.spec.js.map